xfstests: convert tests to use new results directory
[xfstests-dev.git] / tests / xfs / 137
1 #! /bin/bash
2 # FSQA Test No. 137
3 #
4 # Test for NULL files problem
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 seqres=$RESULT_DIR/$seq
28 seqres=$RESULT_DIR/$seq
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1    # failure is the default!
34 trap "_cleanup; exit \$status" 0 1 2 3 15
35
36 _cleanup()
37 {
38     _cleanup_testdir
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os Linux IRIX
48
49 _setup_testdir
50 _require_scratch
51 _scratch_mkfs_xfs >/dev/null 2>&1
52 _scratch_mount
53
54 # create files
55 i=1;
56 while [ $i -lt 1000 ]
57 do
58         file=$SCRATCH_MNT/$i
59         xfs_io -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
60         if [ $? -ne 0 ]
61         then
62                 echo error creating/writing file $file
63                 exit
64         fi
65         let i=$i+1
66 done
67
68 # give the system a chance to write something out
69 sleep 10
70
71 src/godown $SCRATCH_MNT
72
73 umount $SCRATCH_MNT
74 _scratch_mount
75 umount $SCRATCH_MNT
76 if [ ! _check_scratch_fs ]
77 then
78         echo error detected in filesystem
79         exit
80 fi
81 _scratch_mount
82
83 # check file size and contents
84 i=1;
85 while [ $i -lt 1000 ]
86 do
87         file=$SCRATCH_MNT/$i
88         # if file does not exist, the create was not logged, skip it
89         if [ -e $file ]
90         then
91                 # if file size is zero it cannot be corrupt, skip it
92                 if [ -s $file ]
93                 then
94                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
95                         if xfs_bmap $file | grep 'no extents' > /dev/null
96                         then
97                                 echo corrupt file $file - non-zero size but no extents
98                         elif xfs_bmap $file | grep 'hole' > /dev/null
99                         then
100                                 echo corrupt file $file - contains holes
101                         else
102                                 rm -f $file
103                         fi
104                 else
105                         rm -f $file
106                 fi
107         fi
108         let i=$i+1
109 done
110
111 status=0
112 exit